package com.pj.project.tb_driver;

import cn.dev33.satoken.annotation.SaCheckPermission;
import cn.hutool.core.util.IdcardUtil;
import cn.hutool.core.util.StrUtil;
import com.pj.project4sp.SP;
import com.pj.utils.sg.AjaxJson;
import com.pj.utils.so.SoMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


/**
 * Controller: tb_driver -- 司机
 * @author qzy 
 */
@RestController
@RequestMapping("/TbDriver/")
public class TbDriverController {

	/** 底层 Service 对象 */
	@Autowired
	TbDriverService tbDriverService;

	/** 增 */  
	@RequestMapping("add")
	@SaCheckPermission(TbDriver.PERMISSION_CODE)
	@Transactional(rollbackFor = Exception.class)
	public AjaxJson add(TbDriver t){
		tbDriverService.add(t);
		t = tbDriverService.getById(SP.publicMapper.getPrimarykey());
		return AjaxJson.getSuccessData(t);
	}

	/** 删 */  
	@RequestMapping("delete")
	@SaCheckPermission(TbDriver.PERMISSION_CODE)
	public AjaxJson delete(Long id){
		int line = tbDriverService.delete(id);
		return AjaxJson.getByLine(line);
	}
	
	/** 删 - 根据id列表 */  
	@RequestMapping("deleteByIds")
	@SaCheckPermission(TbDriver.PERMISSION_CODE)
	public AjaxJson deleteByIds(){
		List<Long> ids = SoMap.getRequestSoMap().getListByComma("ids", long.class);
		int line = SP.publicMapper.deleteByIds(TbDriver.TABLE_NAME, ids);
		return AjaxJson.getByLine(line);
	}
	
	/** 改 */  
	@RequestMapping("update")
	@SaCheckPermission(TbDriver.PERMISSION_CODE)
	public AjaxJson update(TbDriver t){
		int line = tbDriverService.update(t);
		return AjaxJson.getByLine(line);
	}

	/** 查 - 根据id */  
	@RequestMapping("getById")
	public AjaxJson getById(Long id){
		TbDriver t = tbDriverService.getById(id);
		return AjaxJson.getSuccessData(t);
	}

	/** 查集合 - 根据条件（参数为空时代表忽略指定条件） */  
	@RequestMapping("getList")
	public AjaxJson getList() {
		SoMap so = SoMap.getRequestSoMap();
		List<TbDriver> list = tbDriverService.getList(so.startPage());
		list.forEach(tbDriver -> {
			String idCard=tbDriver.getIdCard();
			String b=IdcardUtil.getBirthByIdCard(idCard);
			if (StrUtil.isNotEmpty(b)){
				tbDriver.setIdCard(idCard.replace(b,"******"));
			}
		});
		return AjaxJson.getPageData(so.getDataCount(), list);
	}
	
	
	
	
	// ------------------------- 前端接口 -------------------------
	
	

	
	
	
	
	

}
